ImmutableBiMap
Date: 2016-05-24

com.google.common.collect

## Class ImmutableBiMap<K,V>

- java.lang.Object
- - com.google.common.collect.ImmutableMap<K,V>
  - - com.google.common.collect.ImmutableBiMap<K,V>

- All Implemented Interfaces:
    BiMap<K,V>, java.io.Serializable, java.util.Map<K,V>

      @GwtCompatible(serializable=true,
                     emulated=true)
      public abstract class ImmutableBiMap<K,V>
      extends ImmutableMap<K,V>
      implements BiMap<K,V>

  A `BiMap` whose contents will never change, with many other important properties detailed at `ImmutableCollection`.
  Since:
    2.0
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ImmutableBiMap.Builder<K,V>` A builder for creating immutable bimap instances, especially `public static final` bimaps ("constant bimaps").

    - ### Nested classes/interfaces inherited from interface java.util.Map

      `java.util.Map.Entry<K,V>`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <K,V> ImmutableBiMap.Builder<K,V>` | `builder()` Returns a new builder.
    `static <K,V> ImmutableBiMap<K,V>` | `copyOf(java.lang.Iterable<? extends java.util.Map.Entry<? extends K,? extends V>> entries)` Returns an immutable bimap containing the given entries.
    `static <K,V> ImmutableBiMap<K,V>` | `copyOf(java.util.Map<? extends K,? extends V> map)` Returns an immutable bimap containing the same entries as `map`.
    `V` | `forcePut(K key, V value)` Deprecated. Unsupported operation.
    `abstract ImmutableBiMap<V,K>` | `inverse()` Returns the inverse view of this bimap, which maps each of this bimap's values to its associated key.
    `static <K,V> ImmutableBiMap<K,V>` | `of()` Returns the empty bimap.
    `static <K,V> ImmutableBiMap<K,V>` | `of(K k1, V v1)` Returns an immutable bimap containing a single entry.
    `static <K,V> ImmutableBiMap<K,V>` | `of(K k1, V v1, K k2, V v2)` Returns an immutable map containing the given entries, in order.
    `static <K,V> ImmutableBiMap<K,V>` | `of(K k1, V v1, K k2, V v2, K k3, V v3)` Returns an immutable map containing the given entries, in order.
    `static <K,V> ImmutableBiMap<K,V>` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4)` Returns an immutable map containing the given entries, in order.
    `static <K,V> ImmutableBiMap<K,V>` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4, K k5, V v5)` Returns an immutable map containing the given entries, in order.
    `ImmutableSet<V>` | `values()` Returns an immutable set of the values in this map.

    - ### Methods inherited from class com.google.common.collect.ImmutableMap

      `asMultimap, clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.common.collect.BiMap

      `put, putAll`

    - ### Methods inherited from interface java.util.Map

      `clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, remove, size`

- - ### Method Detail

    - #### of

          public static <K,V> ImmutableBiMap<K,V> of()

      Returns the empty bimap.

    - #### of

          public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                     V v1)

      Returns an immutable bimap containing a single entry.

    - #### of

          public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                     V v1,
                                     K k2,
                                     V v2)

      Returns an immutable map containing the given entries, in order.
      Throws:
        `java.lang.IllegalArgumentException` - if duplicate keys or values are added

    - #### of

          public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                     V v1,
                                     K k2,
                                     V v2,
                                     K k3,
                                     V v3)

      Returns an immutable map containing the given entries, in order.
      Throws:
        `java.lang.IllegalArgumentException` - if duplicate keys or values are added

    - #### of

          public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                     V v1,
                                     K k2,
                                     V v2,
                                     K k3,
                                     V v3,
                                     K k4,
                                     V v4)

      Returns an immutable map containing the given entries, in order.
      Throws:
        `java.lang.IllegalArgumentException` - if duplicate keys or values are added

    - #### of

          public static <K,V> ImmutableBiMap<K,V> of(K k1,
                                     V v1,
                                     K k2,
                                     V v2,
                                     K k3,
                                     V v3,
                                     K k4,
                                     V v4,
                                     K k5,
                                     V v5)

      Returns an immutable map containing the given entries, in order.
      Throws:
        `java.lang.IllegalArgumentException` - if duplicate keys or values are added

    - #### builder

          public static <K,V> ImmutableBiMap.Builder<K,V> builder()

      Returns a new builder. The generated builder is equivalent to the builder created by the `ImmutableBiMap.Builder` constructor.

    - #### copyOf

          public static <K,V> ImmutableBiMap<K,V> copyOf(java.util.Map<? extends K,? extends V> map)

      Returns an immutable bimap containing the same entries as `map`. If `map` somehow contains entries with duplicate keys (for example, if it is a `SortedMap` whose comparator is not consistent with equals), the results of this method are undefined.

      Despite the method name, this method attempts to avoid actually copying the data when it is safe to do so. The exact circumstances under which a copy will or will not be performed are undocumented and subject to change.

      Throws:
        `java.lang.IllegalArgumentException` - if two keys have the same value
        `java.lang.NullPointerException` - if any key or value in `map` is null

    - #### copyOf

          @Beta
          public static <K,V> ImmutableBiMap<K,V> copyOf(java.lang.Iterable<? extends java.util.Map.Entry<? extends K,? extends V>> entries)

      Returns an immutable bimap containing the given entries.
      Throws:
        `java.lang.IllegalArgumentException` - if two keys have the same value or two values have the same key
        `java.lang.NullPointerException` - if any key, value, or entry is null
      Since:
        19.0

    - #### inverse

          public abstract ImmutableBiMap<V,K> inverse()

      Returns the inverse view of this bimap, which maps each of this bimap's values to its associated key. The two bimaps are backed by the same data; any changes to one will appear in the other.

      Note:There is no guaranteed correspondence between the iteration order of a bimap and that of its inverse.

      The inverse of an `ImmutableBiMap` is another `ImmutableBiMap`.

      Specified by:
        `inverse` in interface `BiMap<K,V>`
      Returns:
        the inverse view of this bimap

    - #### values

          public ImmutableSet<V> values()

      Returns an immutable set of the values in this map. The values are in the same order as the parameters used to build this map.
      Specified by:
        `values` in interface `BiMap<K,V>`
      Specified by:
        `values` in interface `java.util.Map<K,V>`
      Overrides:
        `values` in class `ImmutableMap<K,V>`

    - #### forcePut

          @Deprecated
          public V forcePut(K key,
                              V value)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the bimap unmodified.
      Specified by:
        `forcePut` in interface `BiMap<K,V>`
      Parameters:
        `key` - the key with which the specified value is to be associated
        `value` - the value to be associated with the specified key
      Returns:
        the value which was previously associated with the key, which may be `null`, or `null` if there was no previous entry
      Throws:
        `java.lang.UnsupportedOperationException` - always